diff --git a/target/linux/ar71xx/base-files/etc/diag.sh b/target/linux/ar71xx/base-files/etc/diag.sh
index 4bdb53d..6b885b2 100644
--- a/target/linux/ar71xx/base-files/etc/diag.sh
+++ b/target/linux/ar71xx/base-files/etc/diag.sh
@@ -159,6 +159,9 @@ get_status_led() {
 	om5p-an)
 		status_led="om5p:blue:power"
 		;;
+	onion-omega)
+		status_led="onion:amber:system"
+		;;
 	pb44)
 		status_led="pb44:amber:jump1"
 		;;
diff --git a/target/linux/ar71xx/base-files/etc/uci-defaults/02_network b/target/linux/ar71xx/base-files/etc/uci-defaults/02_network
index 4fe951e..2a43c2c 100644
--- a/target/linux/ar71xx/base-files/etc/uci-defaults/02_network
+++ b/target/linux/ar71xx/base-files/etc/uci-defaults/02_network
@@ -274,6 +274,10 @@ mynet-n750)
 	[ -n "$mac" ] && ucidef_set_interface_macaddr "wan" "$mac"
 	;;
 
+onion-omega)
+	ucidef_set_interface_lan "wlan0"
+	;;
+
 dhp-1565-a1 |\
 dir-835-a1 |\
 wndr3700v4 | \
diff --git a/target/linux/ar71xx/base-files/lib/ar71xx.sh b/target/linux/ar71xx/base-files/lib/ar71xx.sh
index 8f4bb40..1315859 100755
--- a/target/linux/ar71xx/base-files/lib/ar71xx.sh
+++ b/target/linux/ar71xx/base-files/lib/ar71xx.sh
@@ -538,6 +538,9 @@ ar71xx_board_detect() {
 	*"OM5P AN")
 		name="om5p-an"
 		;;
+	*"Onion Omega")
+		name="onion-omega"
+		;;
 	*PB42)
 		name="pb42"
 		;;
diff --git a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
index ade47fb..f5f4adb 100755
--- a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
@@ -305,6 +305,7 @@ platform_check_image() {
 	el-mini | \
 	gl-inet | \
 	mc-mac1200r | \
+	onion-omega | \
 	oolite | \
 	smart-300 | \
 	tl-mr10u | \
diff --git a/target/linux/ar71xx/config-3.18 b/target/linux/ar71xx/config-3.18
index 05c98eb..8167134 100644
--- a/target/linux/ar71xx/config-3.18
+++ b/target/linux/ar71xx/config-3.18
@@ -82,6 +82,7 @@ CONFIG_ATH79_MACH_NBG460N=y
 CONFIG_ATH79_MACH_NBG6716=y
 CONFIG_ATH79_MACH_OM2P=y
 CONFIG_ATH79_MACH_OM5P=y
+CONFIG_ATH79_MACH_ONION_OMEGA=y
 CONFIG_ATH79_MACH_PB42=y
 CONFIG_ATH79_MACH_PB44=y
 CONFIG_ATH79_MACH_PB92=y
diff --git a/target/linux/ar71xx/image/Makefile b/target/linux/ar71xx/image/Makefile
index a2a66b8..dc0b6db 100644
--- a/target/linux/ar71xx/image/Makefile
+++ b/target/linux/ar71xx/image/Makefile
@@ -329,6 +329,15 @@ define Device/mc-mac1200r
 endef
 TARGET_DEVICES += mc-mac1200r
 
+define Device/onion-omega
+    $(Device/tplink-16mlzma)
+    BOARDNAME := ONION-OMEGA
+    DEVICE_PROFILE := OMEGA
+    TPLINK_HWID := 0x04700001
+    CONSOLE := ttyATH0,115200
+endef
+TARGET_DEVICES += onion-omega
+
 define Device/tl-mr10u-v1
     $(Device/tplink-4mlzma)
     BOARDNAME := TL-MR10U
diff --git a/target/linux/ar71xx/patches-3.18/610-MIPS-ath79-openwrt-machines.patch b/target/linux/ar71xx/patches-3.18/610-MIPS-ath79-openwrt-machines.patch
index d6b6aab..590bb2b 100644
--- a/target/linux/ar71xx/patches-3.18/610-MIPS-ath79-openwrt-machines.patch
+++ b/target/linux/ar71xx/patches-3.18/610-MIPS-ath79-openwrt-machines.patch
@@ -1,6 +1,8 @@
---- a/arch/mips/ath79/machtypes.h
-+++ b/arch/mips/ath79/machtypes.h
-@@ -16,22 +16,192 @@
+Index: linux-3.18.18/arch/mips/ath79/machtypes.h
+===================================================================
+--- linux-3.18.18.orig/arch/mips/ath79/machtypes.h
++++ linux-3.18.18/arch/mips/ath79/machtypes.h
+@@ -16,22 +16,193 @@
  
  enum ath79_mach_type {
  	ATH79_MACH_GENERIC = 0,
@@ -72,6 +74,7 @@
 +	ATH79_MACH_OM2Pv2,		/* OpenMesh OM2Pv2 */
 +	ATH79_MACH_OM2P,		/* OpenMesh OM2P */
 +	ATH79_MACH_OM5P,		/* OpenMesh OM5P */
++	ATH79_MACH_ONION_OMEGA,		/* ONION OMEGA */
 +	ATH79_MACH_PB42,		/* Atheros PB42 */
 +	ATH79_MACH_PB92,		/* Atheros PB92 */
 +	ATH79_MACH_QIHOO_C301,		/* Qihoo 360 C301 */
@@ -193,8 +196,10 @@
  };
  
  #endif /* _ATH79_MACHTYPE_H */
---- a/arch/mips/ath79/Kconfig
-+++ b/arch/mips/ath79/Kconfig
+Index: linux-3.18.18/arch/mips/ath79/Kconfig
+===================================================================
+--- linux-3.18.18.orig/arch/mips/ath79/Kconfig
++++ linux-3.18.18/arch/mips/ath79/Kconfig
 @@ -2,6 +2,70 @@ if ATH79
  
  menu "Atheros AR71XX/AR724X/AR913X machine selection"
@@ -266,7 +271,7 @@
  config ATH79_MACH_AP121
  	bool "Atheros AP121 reference board"
  	select SOC_AR933X
-@@ -11,62 +75,996 @@ config ATH79_MACH_AP121
+@@ -11,62 +75,1006 @@ config ATH79_MACH_AP121
  	select ATH79_DEV_M25P80
  	select ATH79_DEV_USB
  	select ATH79_DEV_WMAC
@@ -674,6 +679,16 @@
 +	select ATH79_DEV_M25P80
 +	select ATH79_DEV_WMAC
 +
++config ATH79_MACH_ONION_OMEGA
++	bool "ONION OMEGA support"
++	select SOC_AR933X
++	select ATH79_DEV_ETH
++	select ATH79_DEV_GPIO_BUTTONS
++	select ATH79_DEV_LEDS_GPIO
++	select ATH79_DEV_M25P80
++	select ATH79_DEV_USB
++	select ATH79_DEV_WMAC
++
 +config ATH79_MACH_GS_OOLITE
 +       bool "GS Oolite V1 support"
 +       select SOC_AR933X
@@ -1291,7 +1306,7 @@
  
  config ATH79_MACH_UBNT_XM
  	bool "Ubiquiti Networks XM/UniFi boards"
-@@ -83,6 +1081,97 @@ config ATH79_MACH_UBNT_XM
+@@ -83,6 +1091,97 @@ config ATH79_MACH_UBNT_XM
  	  Say 'Y' here if you want your kernel to support the
  	  Ubiquiti Networks XM (rev 1.0) board.
  
@@ -1389,7 +1404,7 @@
  endmenu
  
  config SOC_AR71XX
-@@ -124,7 +1213,10 @@ config ATH79_DEV_DSA
+@@ -124,7 +1223,10 @@ config ATH79_DEV_DSA
  config ATH79_DEV_ETH
  	def_bool n
  
@@ -1401,7 +1416,7 @@
  	def_bool n
  
  config ATH79_DEV_GPIO_BUTTONS
-@@ -154,6 +1246,11 @@ config ATH79_PCI_ATH9K_FIXUP
+@@ -154,6 +1256,11 @@ config ATH79_PCI_ATH9K_FIXUP
  	def_bool n
  
  config ATH79_ROUTERBOOT
@@ -1413,9 +1428,11 @@
  	def_bool n
  
  endif
---- a/arch/mips/ath79/Makefile
-+++ b/arch/mips/ath79/Makefile
-@@ -38,9 +38,121 @@ obj-$(CONFIG_ATH79_ROUTERBOOT)		+= route
+Index: linux-3.18.18/arch/mips/ath79/Makefile
+===================================================================
+--- linux-3.18.18.orig/arch/mips/ath79/Makefile
++++ linux-3.18.18/arch/mips/ath79/Makefile
+@@ -38,9 +38,122 @@ obj-$(CONFIG_ATH79_ROUTERBOOT)		+= route
  #
  # Machines
  #
@@ -1468,6 +1485,7 @@
 +obj-$(CONFIG_ATH79_MACH_NBG460N)	+= mach-nbg460n.o
 +obj-$(CONFIG_ATH79_MACH_OM2P)		+= mach-om2p.o
 +obj-$(CONFIG_ATH79_MACH_OM5P)		+= mach-om5p.o
++obj-$(CONFIG_ATH79_MACH_ONION_OMEGA)	+= mach-onion-omega.o
 +obj-$(CONFIG_ATH79_MACH_PB42)		+= mach-pb42.o
  obj-$(CONFIG_ATH79_MACH_PB44)		+= mach-pb44.o
 +obj-$(CONFIG_ATH79_MACH_PB92)		+= mach-pb92.o
@@ -1537,8 +1555,10 @@
 +obj-$(CONFIG_ATH79_MACH_ZCN_1523H)	+= mach-zcn-1523h.o
 +obj-$(CONFIG_ATH79_MACH_CARAMBOLA2)	+= mach-carambola2.o
 +obj-$(CONFIG_ATH79_MACH_NBG6716)	+= mach-nbg6716.o
---- a/arch/mips/ath79/prom.c
-+++ b/arch/mips/ath79/prom.c
+Index: linux-3.18.18/arch/mips/ath79/prom.c
+===================================================================
+--- linux-3.18.18.orig/arch/mips/ath79/prom.c
++++ linux-3.18.18/arch/mips/ath79/prom.c
 @@ -180,6 +180,12 @@ void __init prom_init(void)
  			ath79_prom_append_cmdline("board", env);
  		}
diff --git a/tools/firmware-utils/src/mktplinkfw.c b/tools/firmware-utils/src/mktplinkfw.c
index 09536c6..c52627a 100644
--- a/tools/firmware-utils/src/mktplinkfw.c
+++ b/tools/firmware-utils/src/mktplinkfw.c
@@ -33,6 +33,7 @@
 #define HWID_ANTMINER_S1	0x04440001
 #define HWID_GL_INET_V1		0x08000001
 #define HWID_GS_OOLITE_V1	0x3C000101
+#define HWID_ONION_OMEGA	0x04700001
 #define HWID_TL_MR10U_V1	0x00100101
 #define HWID_TL_MR13U_V1	0x00130101
 #define HWID_TL_MR3020_V1	0x30200001
@@ -419,6 +420,11 @@ static struct board_info boards[] = {
 		.hw_rev		= 1,
 		.layout_id	= "16Mlzma",
 	}, {
+		.id		= "ONION-OMEGA",
+		.hw_id		= HWID_ONION_OMEGA,
+		.hw_rev		= 1,
+		.layout_id	= "16Mlzma",
+	}, {
 		.id		= "ANTMINER-S1",
 		.hw_id		= HWID_ANTMINER_S1,
 		.hw_rev		= 1,